Index: kernel/generic/include/arch.h
===================================================================
--- kernel/generic/include/arch.h	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/include/arch.h	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -66,7 +66,4 @@
 typedef struct {
 	size_t preemption;     /**< Preemption disabled counter and flag. */
-#ifdef RCU_PREEMPT_A
-	size_t rcu_nesting;    /**< RCU nesting count and flag. */
-#endif
 	struct thread *thread; /**< Current thread. */
 	struct task *task;     /**< Current task. */
Index: kernel/generic/include/cpu.h
===================================================================
--- kernel/generic/include/cpu.h	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/include/cpu.h	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -38,5 +38,4 @@
 #include <mm/tlb.h>
 #include <synch/spinlock.h>
-#include <synch/rcu_types.h>
 #include <proc/scheduler.h>
 #include <arch/cpu.h>
@@ -104,7 +103,4 @@
 	list_t smp_pending_calls;
 
-	/** RCU per-cpu data. Uses own locking. */
-	rcu_cpu_data_t rcu;
-
 	/**
 	 * Stack used by scheduler when there is no running thread.
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/include/proc/task.h	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -43,6 +43,4 @@
 #include <synch/mutex.h>
 #include <synch/futex.h>
-#include <synch/workqueue.h>
-#include <adt/cht.h>
 #include <adt/list.h>
 #include <adt/odict.h>
Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/include/proc/thread.h	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -41,5 +41,4 @@
 #include <cpu.h>
 #include <synch/spinlock.h>
-#include <synch/rcu_types.h>
 #include <adt/odict.h>
 #include <mm/slab.h>
@@ -194,16 +193,4 @@
 	thread_id_t tid;
 
-	/** Work queue this thread belongs to or NULL. Immutable. */
-	struct work_queue *workq;
-	/** Links work queue threads. Protected by workq->lock. */
-	link_t workq_link;
-	/** True if the worker was blocked and is not running. Use thread->lock. */
-	bool workq_blocked;
-	/** True if the worker will block in order to become idle. Use workq->lock. */
-	bool workq_idling;
-
-	/** RCU thread related data. Protected by its own locks. */
-	rcu_thread_data_t rcu;
-
 	/** Architecture-specific data. */
 	thread_arch_t arch;
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/src/console/cmd.c	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -70,6 +70,4 @@
 #include <sysinfo/sysinfo.h>
 #include <symtab.h>
-#include <synch/workqueue.h>
-#include <synch/rcu.h>
 #include <errno.h>
 
@@ -536,22 +534,4 @@
 };
 
-/* Data and methods for the 'workq' command */
-static int cmd_workq(cmd_arg_t *argv);
-static cmd_info_t workq_info = {
-	.name = "workq",
-	.description = "Show global workq information.",
-	.func = cmd_workq,
-	.argc = 0
-};
-
-/* Data and methods for the 'workq' command */
-static int cmd_rcu(cmd_arg_t *argv);
-static cmd_info_t rcu_info = {
-	.name = "rcu",
-	.description = "Show RCU run-time statistics.",
-	.func = cmd_rcu,
-	.argc = 0
-};
-
 /* Data and methods for 'ipc' command */
 static int cmd_ipc(cmd_arg_t *argv);
@@ -618,5 +598,4 @@
 	&physmem_info,
 	&reboot_info,
-	&rcu_info,
 	&sched_info,
 	&set4_info,
@@ -628,5 +607,4 @@
 	&uptime_info,
 	&version_info,
-	&workq_info,
 	&zones_info,
 	&zone_info,
@@ -1302,28 +1280,4 @@
 }
 
-/** Prints information about the global work queue.
- *
- * @param argv Ignores
- *
- * @return Always 1
- */
-int cmd_workq(cmd_arg_t *argv)
-{
-	workq_global_print_info();
-	return 1;
-}
-
-/** Prints RCU statistics.
- *
- * @param argv Ignores
- *
- * @return Always 1
- */
-int cmd_rcu(cmd_arg_t *argv)
-{
-	rcu_print_stat();
-	return 1;
-}
-
 /** Command for listing memory zones
  *
Index: kernel/generic/src/cpu/cpu.c
===================================================================
--- kernel/generic/src/cpu/cpu.c	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/src/cpu/cpu.c	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -50,5 +50,4 @@
 #include <sysinfo/sysinfo.h>
 #include <arch/cycle.h>
-#include <synch/rcu.h>
 
 cpu_t *cpus;
@@ -108,5 +107,4 @@
 	cpu_identify();
 	cpu_arch_init();
-	rcu_cpu_init();
 }
 
Index: kernel/generic/src/main/kinit.c
===================================================================
--- kernel/generic/src/main/kinit.c	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/src/main/kinit.c	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -79,6 +79,4 @@
 #include <synch/waitq.h>
 #include <synch/spinlock.h>
-#include <synch/workqueue.h>
-#include <synch/rcu.h>
 
 #define ALIVE_CHARS  4
@@ -109,12 +107,4 @@
 
 	interrupts_disable();
-
-	/* Start processing RCU callbacks. RCU is fully functional afterwards. */
-	rcu_kinit_init();
-
-	/*
-	 * Start processing work queue items. Some may have been queued during boot.
-	 */
-	workq_global_worker_init();
 
 #ifdef CONFIG_SMP
Index: kernel/generic/src/main/main.c
===================================================================
--- kernel/generic/src/main/main.c	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/src/main/main.c	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -78,5 +78,4 @@
 #include <synch/waitq.h>
 #include <synch/futex.h>
-#include <synch/workqueue.h>
 #include <smp/smp_call.h>
 #include <arch/arch.h>
@@ -275,5 +274,4 @@
 
 	smp_call_init();
-	workq_global_init();
 	clock_counter_init();
 	timeout_init();
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/src/proc/scheduler.c	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -54,6 +54,4 @@
 #include <atomic.h>
 #include <synch/spinlock.h>
-#include <synch/workqueue.h>
-#include <synch/rcu.h>
 #include <config.h>
 #include <context.h>
@@ -90,5 +88,4 @@
 {
 	before_thread_runs_arch();
-	rcu_before_thread_runs();
 
 #ifdef CONFIG_FPU_LAZY
@@ -131,6 +128,4 @@
 static void after_thread_ran(void)
 {
-	workq_after_thread_ran();
-	rcu_after_thread_ran();
 	after_thread_ran_arch();
 }
@@ -430,5 +425,4 @@
 
 		case Exiting:
-			rcu_thread_exiting();
 		repeat:
 			if (THREAD->detached) {
Index: kernel/generic/src/proc/the.c
===================================================================
--- kernel/generic/src/proc/the.c	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/src/proc/the.c	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -60,7 +60,4 @@
 	the->as = NULL;
 	the->magic = MAGIC;
-#ifdef RCU_PREEMPT_A
-	the->rcu_nesting = 0;
-#endif
 }
 
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision 947ab77e1138e5b43ed8d4e74ae82a491381bfec)
+++ kernel/generic/src/proc/thread.c	(revision aae365bc823f3137811d2c48089c150e81c40606)
@@ -48,6 +48,4 @@
 #include <synch/spinlock.h>
 #include <synch/waitq.h>
-#include <synch/workqueue.h>
-#include <synch/rcu.h>
 #include <cpu.h>
 #include <str.h>
@@ -69,4 +67,5 @@
 #include <syscall/copy.h>
 #include <errno.h>
+#include <debug.h>
 
 /** Thread states */
@@ -272,5 +271,4 @@
 {
 	assert(irq_spinlock_locked(&thread->lock));
-	workq_before_thread_is_ready(thread);
 }
 
@@ -399,6 +397,4 @@
 	thread->task = task;
 
-	thread->workq = NULL;
-
 	thread->fpu_context_exists = false;
 	thread->fpu_context_engaged = false;
@@ -414,6 +410,4 @@
 	/* Might depend on previous initialization */
 	thread_create_arch(thread);
-
-	rcu_thread_init(thread);
 
 	if ((flags & THREAD_FLAG_NOATTACH) != THREAD_FLAG_NOATTACH)
